Package org.apache.velocity.runtime.parser.node

# Class ASTOrNode

java.lang.Object
org.apache.velocity.runtime.parser.node.SimpleNode
org.apache.velocity.runtime.parser.node.ASTBinaryOperator
org.apache.velocity.runtime.parser.node.ASTLogicalOperator
org.apache.velocity.runtime.parser.node.ASTOrNode

All Implemented Interfaces:
  `Cloneable`, `Node`, `Renderable`

public class ASTOrNode extends ASTLogicalOperator
Please look at the Parser.jjt file which is what controls the generation of this class.

Version:
  $Id$
Author:
  Jason van Zyl, Geir Magnusson Jr.

## Field Summary

### Fields inherited from class org.apache.velocity.runtime.parser.node.SimpleNode

`children, column, first, firstImage, id, info, invalid, last, lastImage, line, literal, log, parent, parser, rsvc, state, template`

## Constructor Summary

Constructors
Constructor
Description
`ASTOrNode(int id)`
`ASTOrNode(Parser p, int id)`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`evaluate(InternalContextAdapter context)`
the logical or :
`String`
`getLiteralOperator()`
get the string representing the mathematical operator
`Object`
`jjtAccept(StandardParserVisitor visitor, Object data)`
`Object`
`value(InternalContextAdapter context)`
Returns the value of the expression.

### Methods inherited from class org.apache.velocity.runtime.parser.node.ASTLogicalOperator

`init`

### Methods inherited from class org.apache.velocity.runtime.parser.node.ASTBinaryOperator

`literal`

### Methods inherited from class org.apache.velocity.runtime.parser.node.SimpleNode

`childrenAccept, cleanupParserAndTokens, clone, clone, dump, dump, dump, execute, getColumn, getFirstToken, getFirstTokenImage, getInfo, getLastToken, getLastTokenImage, getLine, getLocation, getParser, getRuntimeServices, getTemplate, getTemplateName, getType, isInvalid, jjtAddChild, jjtClose, jjtGetChild, jjtGetNumChildren, jjtGetParent, jjtOpen, jjtSetParent, render, saveTokenImages, setFirstToken, setInfo, setInvalid, toString, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ASTOrNode

public ASTOrNode(int id)

Parameters:
  `id` -

### ASTOrNode

public ASTOrNode(Parser p, int id)

Parameters:
  `p` -
  `id` -

## Method Details

### getLiteralOperator

public String getLiteralOperator()
Description copied from class: `ASTBinaryOperator`
get the string representing the mathematical operator

Specified by:
  `getLiteralOperator` in class `ASTBinaryOperator`
Returns:
  operator string

### jjtAccept

public Object jjtAccept(StandardParserVisitor visitor, Object data)

Specified by:
  `jjtAccept` in interface `Node`
Overrides:
  `jjtAccept` in class `SimpleNode`
Parameters:
  `visitor` -
  `data` -
Returns:
  The Node execution result object.
See Also:
  - `SimpleNode.jjtAccept(org.apache.velocity.runtime.parser.node.StandardParserVisitor, java.lang.Object)`

### value

public Object value(InternalContextAdapter context) throws MethodInvocationException
Returns the value of the expression. Since the value of the expression is simply the boolean result of evaluate(), lets return that.

Specified by:
  `value` in interface `Node`
Overrides:
  `value` in class `SimpleNode`
Parameters:
  `context` -
Returns:
  The Expression value.
Throws:
  `MethodInvocationException`
See Also:
  - `Node.value(org.apache.velocity.context.InternalContextAdapter)`

### evaluate

public boolean evaluate(InternalContextAdapter context) throws MethodInvocationException
the logical or :

          left || null -> left
          null || right -> right
          null || null -> false
          left || right ->  left || right

Specified by:
  `evaluate` in interface `Node`
Overrides:
  `evaluate` in class `SimpleNode`
Parameters:
  `context` -
Returns:
  The evaluation result.
Throws:
  `MethodInvocationException`
See Also:
  - `Node.evaluate(org.apache.velocity.context.InternalContextAdapter)`